(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["default~modals-overtime-modal-overtime-modal-module~pages-activities-activities-module"],{

/***/ "3plf":
/*!**********************************************!*\
  !*** ./src/app/services/overtime.service.ts ***!
  \**********************************************/
/*! exports provided: OvertimeService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OvertimeService", function() { return OvertimeService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _auth_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./auth.service */ "lGQG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var _angular_common_http__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @angular/common/http */ "tk/3");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! rxjs/operators */ "kU1M");






let OvertimeService = class OvertimeService {
    constructor(authService, http) {
        this.authService = authService;
        this.http = http;
        this.base_path = authService.serverAdress + '/overtimes';
        this.workerId = 0;
        this.state = 0;
        this.datefrom = new Date();
        this.dateto = new Date();
    }
    // Handle API errors
    handleError(error) {
        if (error.error instanceof ErrorEvent) {
            // A client-side or network error occurred. Handle it accordingly.
            console.error('An error occurred:', error.error.message);
        }
        else {
            // The backend returned an unsuccessful response code.
            // The response body may contain clues as to what went wrong,
            console.log(`Backend returned code ${error.status}, ` +
                `body was: ${error.error}`);
            console.log(JSON.stringify(error.error));
        }
        // return an observable with a user-facing error message
        return Object(rxjs__WEBPACK_IMPORTED_MODULE_4__["throwError"])('Something bad happened; please try again later.');
    }
    ;
    // Create a new item
    createItem(item) {
        return this.http
            .post(this.base_path, JSON.stringify(item), this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Get single student data by ID
    getItem(id) {
        return this.http
            .get(this.base_path + '/' + id, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Update item by id
    updateItem(id, item) {
        return this.http
            .put(this.base_path + '/' + id, JSON.stringify(item), this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Delete item by id
    deleteItem(id) {
        return this.http
            .delete(this.base_path + '/' + id, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // dodatkowe
    getOvertimeWorker() {
        return this.http
            .get(this.base_path + '/worker/' + this.workerId + '?state='
            + this.state + '&listtype=' + this.listtype + '&from=' + this.datefrom + '&to=' + this.dateto, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    getOvertimeWorkDay(workday) {
        return this.http
            .get(this.base_path + '/workday/' + workday, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    getOvertimeWorkerTotal() {
        return this.http
            .get(this.base_path + '/total/' + this.workerId, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
};
OvertimeService.ctorParameters = () => [
    { type: _auth_service__WEBPACK_IMPORTED_MODULE_1__["AuthService"] },
    { type: _angular_common_http__WEBPACK_IMPORTED_MODULE_3__["HttpClient"] }
];
OvertimeService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_2__["Injectable"])({
        providedIn: 'root'
    })
], OvertimeService);



/***/ }),

/***/ "6vRT":
/*!****************************************************************!*\
  !*** ./src/app/modals/overtime-modal/overtime-modal.page.scss ***!
  \****************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("\n/*# sourceMappingURL=data:application/json;base64,eyJ2ZXJzaW9uIjozLCJzb3VyY2VzIjpbXSwibmFtZXMiOltdLCJtYXBwaW5ncyI6IiIsImZpbGUiOiJzcmMvYXBwL21vZGFscy9vdmVydGltZS1tb2RhbC9vdmVydGltZS1tb2RhbC5wYWdlLnNjc3MifQ== */");

/***/ }),

/***/ "bzms":
/*!******************************************************************************************************!*\
  !*** ./node_modules/raw-loader/dist/cjs.js!./src/app/modals/overtime-modal/overtime-modal.page.html ***!
  \******************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("<ion-header>\n  <ion-toolbar color=\"light\">\n    <ion-buttons slot=\"start\"  >\n      <ion-back-button *ngIf=\"!isModal\"></ion-back-button>     \n      <ion-menu-button *ngIf=\"!isModal\"></ion-menu-button>\n      <ion-button  slot=\"icon-only\" [routerLink]=\"['/inbox']\" *ngIf=\"taskService.notyficationCount>0 && !isModal\" >        \n        <ion-icon name='notifications'></ion-icon>\n        <ion-badge>{{taskService.notyficationCount}}</ion-badge>\n      </ion-button>\n      <ion-button fill=\"outline\"  *ngIf=\"overtimeTotal && overtimeTotal.length>0 && overtimeTotal[0].Total!==0\"\n        [color]=\"overtimeTotal[0].Total>0 ? 'danger':'success'\" \n      >\n        <ion-icon name=\"hourglass\"></ion-icon>\n        {{overtimeTotal[0].Total>0? '+':'-'}}\n        {{authService.timeSpendFormat(overtimeTotal[0].Total)}}\n      </ion-button>   \n    </ion-buttons>\n    \n    <ion-title  size=\"small\">Nadgodziny</ion-title>\n    <ion-buttons slot=\"end\">\n      <ion-button fill=\"outline\" (click)=\"getAllActivities()\" *ngIf=\"!refreshing\" color=\"light\">        \n        <ion-icon name=\"refresh\" slot=\"icon-only\" ></ion-icon>   \n      </ion-button>\n      \n  \n      <ion-button (click)=\"selectOperator()\" [fill]=\"selOperator ? 'outline':'outline'\" >\n        <ion-icon *ngIf=\"!selOperator\" [name]=\"selOperator ?'person':'people' \"></ion-icon>\n        <ion-avatar slot=\"start\" *ngIf=\"selOperator\">\n          <img [src]=\"authService.avatarAdress(selOperator.Name)\">\n        </ion-avatar>\n        <span *ngIf=\"selOperator\" >{{selOperator.Name}}</span></ion-button>\n        <ion-button (click)=\"closeModal()\" *ngIf=\"isModal\">{{'COMMON.close' | translate}}</ion-button>\n      \n    \n        <ion-button (click)=\"closeModal()\" *ngIf=\"isModal\">{{'COMMON.close' | translate}}</ion-button>\n        \n    </ion-buttons>\n  </ion-toolbar>\n</ion-header>\n  <ion-toolbar color=\"light\">\n    <ion-row>\n      <ion-col>\n        <ion-item color=\"light\" >\n          <ion-label>{{'COMMON.from' | translate }}</ion-label>\n          <ion-input type=\"date\" [(ngModel)]=\"overtimeService.datefrom\"  debounce=\"700\" (ionBlur)='getOvertimes()'></ion-input>\n        </ion-item>\n  </ion-col>\n  <ion-col>\n    <ion-item color=\"light\" >\n      <ion-label>{{'COMMON.to' | translate }}</ion-label>\n      <ion-input type=\"date\"  [(ngModel)]=\"overtimeService.dateto\" debounce=\"700\" (ionBlur)='getOvertimes()'></ion-input>\n    </ion-item>\n  \n  </ion-col>\n  </ion-row>\n  </ion-toolbar>\n  <ion-toolbar>\n    <ion-segment [(ngModel)]=\"listType\" (ionChange)=\"typeListChange($event)\">\n      <ion-segment-button value=\"waiting\">\n        <ion-label>Oczekujące</ion-label>\n      </ion-segment-button>\n      <ion-segment-button value=\"mine\">\n        <ion-label>Moje </ion-label>\n      </ion-segment-button>\n      <ion-segment-button value=\"requestes\">\n        <ion-label>Wnioskowane</ion-label>\n      </ion-segment-button>        \n    </ion-segment>\n    <ion-buttons slot=\"end\">\n   <ion-button (click)=\"changeState()\" fill=\"outline\" >\n    <ion-icon name=\"pulse\" slot=\"start\"></ion-icon>  \n      {{stateName()}}\n   </ion-button>\n  </ion-buttons>\n  </ion-toolbar>\n\n\n<ion-content>\n  <ion-item *ngFor=\"let overtime of overtimes\">\n    <ion-avatar slot=\"start\">\n      <img [src]=\"authService.avatarAdress(authService.getOperatorNameById(overtime.WorkerId))\">\n    </ion-avatar>\n    <ion-label>\n    <h2>\n      {{authService.formatDate(overtime.Date)}}\n    </h2>\n    <p>{{overtime.Description}}      \n    </p>\n    <p>\n      <ion-chip outline  size=\"small\">    \n        <ion-avatar>\n          <img [src]=\"authService.avatarAdress(authService.getOperatorNameById(overtime.VendorId))\">\n        </ion-avatar>        \n        <ion-label>{{authService.getOperatorNameById(overtime.VendorId)}}</ion-label>            \n      </ion-chip>\n      <ion-chip outline  size=\"small\" color=\"success\" [color]=\"authService.getDictionaryColorById(overtime.State)\" >    \n        <ion-icon name=\"pulse\"  size=\"small\"></ion-icon>\n        <ion-label>\n          {{authService.getDictionaryValueById(overtime.State)}}\n        </ion-label>     \n      </ion-chip>     \n    </p>\n  </ion-label>\n  <ion-badge  [color]=\"overtime.Time>0 ? 'danger':'success'\" >\n    {{overtime.Time>0? '+':'-'}}\n    {{authService.timeSpendFormat( overtime.Time)}}\n  </ion-badge>\n  <ion-buttons slot=\"end\">\n    <ion-button (click)=\"deleteOvertime(overtime)\">\n      <ion-icon name=\"trash\" slot=\"icon-only\" color=\"danger\"></ion-icon>\n    </ion-button>\n    <ion-button (click)=\"openOvertime(overtime)\" color=\"success\">\n      <ion-icon name=\"open\" slot=\"icon-only\" color=\"danger\"></ion-icon>\n    </ion-button>\n  </ion-buttons>\n  </ion-item>\n</ion-content>\n  <ion-footer class=\"light\" *ngIf=\"false\">\n    <ion-row class=\"light\">\n    <ion-col class=\"light\">\n    <ion-item color=\"light\" >\n      <ion-icon name=\"today\" slot=\"start\" color=\"primary\" ></ion-icon>        \n      <ion-input type=\"date\"  [(ngModel)]=\"newDate\"></ion-input>\n    </ion-item>\n    </ion-col>\n    <ion-col class=\"light\">\n      <ion-item color=\"light\" >\n        <ion-icon name=\"stopwatch\" slot=\"start\" color=\"primary\" ></ion-icon>        \n        <ion-input type=\"number\"  [(ngModel)] = \"newtimeSpend\"></ion-input>            \n        <ion-chip [color]=\"newtimeSpend>0 ? 'danger':'success'\"  *ngIf = \"newtimeSpend!=0\">\n          <ion-icon name=\"stopwatch\"></ion-icon>\n          <ion-label>{{authService.timeSpendFormat(newtimeSpend)}}</ion-label>\n        </ion-chip>       \n      </ion-item>\n      </ion-col>\n    </ion-row>\n    <ion-item color=\"light\">\n      <ion-label>\n        {{'COMMON.comment' | translate }}\n      </ion-label>\n      <ion-input type=\"text\"  [(ngModel)] = \"comment\"></ion-input>\n      <ion-button slot=\"end\" >\n        <ion-icon name=\"add\" slot=\"icon-only\" ></ion-icon>\n      </ion-button>\n      \n    </ion-item>\n</ion-footer>\n\n\n");

/***/ }),

/***/ "sABE":
/*!**************************************************************!*\
  !*** ./src/app/modals/overtime-modal/overtime-modal.page.ts ***!
  \**************************************************************/
/*! exports provided: OvertimeModalPage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OvertimeModalPage", function() { return OvertimeModalPage; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _raw_loader_overtime_modal_page_html__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! raw-loader!./overtime-modal.page.html */ "bzms");
/* harmony import */ var _overtime_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./overtime-modal.page.scss */ "6vRT");
/* harmony import */ var _overtimer_detail_modal_overtimer_detail_modal_page__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./../overtimer-detail-modal/overtimer-detail-modal.page */ "umoA");
/* harmony import */ var _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../services/tasks-service.service */ "TPCf");
/* harmony import */ var _angular_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @angular/router */ "tyNb");
/* harmony import */ var _operators_modal_operators_modal_page__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./../operators-modal/operators-modal.page */ "8xRD");
/* harmony import */ var _services_auth_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./../../services/auth.service */ "lGQG");
/* harmony import */ var _services_overtime_service__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./../../services/overtime.service */ "3plf");
/* harmony import */ var _ionic_angular__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @ionic/angular */ "TEn/");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @angular/core */ "fXoL");











let OvertimeModalPage = class OvertimeModalPage {
    constructor(modalController, overtimeService, authService, router, taskService) {
        this.modalController = modalController;
        this.overtimeService = overtimeService;
        this.authService = authService;
        this.router = router;
        this.taskService = taskService;
        this.selOperator = this.authService.getOperatorById(this.overtimeService.workerId);
        this.isModal = (this.router.url.toString()) !== '/overtime-modal';
        this.listType = 'waiting';
        // this.currentState = this.authService.overtimes_states[0].Id;
        this.currentState = 0;
        if (!this.overtimeService.datefrom || !this.overtimeService.dateto) {
            let date = new Date();
            this.overtimeService.datefrom = this.authService.formatDate2(date);
            this.overtimeService.dateto = this.authService.formatDate2(date);
        }
    }
    addDisabled() {
        let res = (this.newDate > this.overtimeService.dateto || this.newDate < this.overtimeService.datefrom || this.newtimeSpend === 0);
        if (res) {
            return true;
        }
        // sprawdzamy czy nie ma już takiej daty
        for (var ot of this.overtimes) {
            if (this.authService.formatDate2(ot.Date) === this.newDate) {
                return true;
            }
        }
        return false;
    }
    ngOnInit() {
    }
    ionViewWillEnter() {
        this.getOvertimes();
    }
    changeState() {
        this.getOvertimes();
    }
    stateName() {
        return this.authService.getDictionaryValueById(this.currentState);
    }
    typeListChange(event) {
        this.getOvertimes();
    }
    getOvertimes() {
        // Get saved list of students
        this.overtimeService.state = this.currentState;
        this.overtimeService.listtype = this.listType;
        this.overtimeService.getOvertimeWorker().subscribe(response => {
            console.log(response);
            this.overtimes = response;
        });
        this.overtimeService.getOvertimeWorkerTotal().subscribe(otot => {
            this.overtimeTotal = otot;
        });
    }
    closeModal() {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            yield this.modalController.dismiss();
        });
    }
    /*
 addOvertime(){
   let newOt = new Overtime(this.overtimeService.workerId,this.newDate, this.newtimeSpend, this.authService.operator.Id, this.comment);
   this.overtimeService.createItem(newOt).subscribe(response => {
     this.comment='';
     this.getOvertimes();
   });
 }
*/
    deleteOvertime(ot) {
        this.overtimeService.deleteItem(ot.Id).subscribe(r => {
            this.getOvertimes();
        });
    }
    openOvertime(overtime) {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            this.overtimeService.currentOvertime = overtime;
            const otmodal = yield this.modalController.create({
                component: _overtimer_detail_modal_overtimer_detail_modal_page__WEBPACK_IMPORTED_MODULE_3__["OvertimerDetailModalPage"]
            });
            otmodal.onWillDismiss().then(dataReturned => {
                //   this.selectedOperator(dataReturned.data);
                this.overtimeService.currentOvertime = undefined;
                this.getOvertimes();
            });
            return yield otmodal.present();
        });
    }
    selectOperator() {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            if (this.authService.operator.PermissionsObj.Overtimes.OthersOvertimes) {
                const modal = yield this.modalController.create({
                    component: _operators_modal_operators_modal_page__WEBPACK_IMPORTED_MODULE_6__["OperatorsModalPage"]
                });
                modal.onWillDismiss().then(dataReturned => {
                    this.selectedOperator(dataReturned.data);
                });
                return yield modal.present();
            }
        });
    }
    selectedOperator(operator) {
        this.selOperator = operator;
        if (operator) {
            this.overtimeService.workerId = operator.Id;
        }
        else {
            this.overtimeService.workerId = 0;
        }
        this.getOvertimes();
    }
};
OvertimeModalPage.ctorParameters = () => [
    { type: _ionic_angular__WEBPACK_IMPORTED_MODULE_9__["ModalController"] },
    { type: _services_overtime_service__WEBPACK_IMPORTED_MODULE_8__["OvertimeService"] },
    { type: _services_auth_service__WEBPACK_IMPORTED_MODULE_7__["AuthService"] },
    { type: _angular_router__WEBPACK_IMPORTED_MODULE_5__["Router"] },
    { type: _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_4__["TasksServiceService"] }
];
OvertimeModalPage = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_10__["Component"])({
        selector: 'app-overtime-modal',
        template: _raw_loader_overtime_modal_page_html__WEBPACK_IMPORTED_MODULE_1__["default"],
        styles: [_overtime_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__["default"]]
    })
], OvertimeModalPage);



/***/ }),

/***/ "sW06":
/*!********************************************************************************!*\
  !*** ./src/app/modals/overtimer-detail-modal/overtimer-detail-modal.page.scss ***!
  \********************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("\n/*# sourceMappingURL=data:application/json;base64,eyJ2ZXJzaW9uIjozLCJzb3VyY2VzIjpbXSwibmFtZXMiOltdLCJtYXBwaW5ncyI6IiIsImZpbGUiOiJzcmMvYXBwL21vZGFscy9vdmVydGltZXItZGV0YWlsLW1vZGFsL292ZXJ0aW1lci1kZXRhaWwtbW9kYWwucGFnZS5zY3NzIn0= */");

/***/ }),

/***/ "umoA":
/*!******************************************************************************!*\
  !*** ./src/app/modals/overtimer-detail-modal/overtimer-detail-modal.page.ts ***!
  \******************************************************************************/
/*! exports provided: OvertimerDetailModalPage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OvertimerDetailModalPage", function() { return OvertimerDetailModalPage; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _raw_loader_overtimer_detail_modal_page_html__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! raw-loader!./overtimer-detail-modal.page.html */ "wQvX");
/* harmony import */ var _overtimer_detail_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./overtimer-detail-modal.page.scss */ "sW06");
/* harmony import */ var _component_task_history_task_history_component__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./../../component/task-history/task-history.component */ "bTDo");
/* harmony import */ var _services_overtime_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../services/overtime.service */ "3plf");
/* harmony import */ var _angular_platform_browser__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @angular/platform-browser */ "jhN1");
/* harmony import */ var _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./../../services/tasks-service.service */ "TPCf");
/* harmony import */ var _services_auth_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./../../services/auth.service */ "lGQG");
/* harmony import */ var _ionic_angular__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ionic/angular */ "TEn/");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @angular/core */ "fXoL");










let OvertimerDetailModalPage = class OvertimerDetailModalPage {
    constructor(modalController, auth, taskService, domSanitizer, overtimes) {
        this.modalController = modalController;
        this.auth = auth;
        this.taskService = taskService;
        this.domSanitizer = domSanitizer;
        this.overtimes = overtimes;
    }
    ngOnInit() {
    }
    closeModal() {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            // zapis...
            yield this.modalController.dismiss();
            /*
            if ( this.workdays.currentDay.Id){
              this.workdays.updateItem(this.workdays.currentDay.Id,this.workdays.currentDay).
              subscribe(res =>
                {
                 this.modalController.dismiss();
              });
            }
            else{
              this.workdays.createItem (this.workdays.currentDay).
              subscribe(res =>
                {
                 this.modalController.dismiss();
              });
            }
            */
            // await this.modalController.dismiss();
        });
    }
    changeState() {
        let textInfo = this.auth.getDictionaryValueById(this.overtimes.currentOvertime.State);
        /*
         if ( this.oldTask!== undefined){
           textInfo = this.auth.getDictionaryValueById(this.oldTask.StateId) +'->' + textInfo;
         }
         */
        this.historyComp.addToHisory(105, this.overtimes.currentOvertime.State, textInfo, 0, 0, 0, 0);
        this.saveOvertime();
    }
    changeVendor() {
        this.saveOvertime();
    }
    saveOvertime() {
        console.log('saveOvertime');
        if (!this.overtimes.currentOvertime.Id) {
            this.overtimes.createItem(this.overtimes.currentOvertime).subscribe(res => {
                this.overtimes.currentOvertime = res;
                console.log('overtime added Updated');
            });
        }
        else {
            this.overtimes.updateItem(this.overtimes.currentOvertime.Id, this.overtimes.currentOvertime)
                .subscribe(res => {
                console.log('overtimeUpdated');
            });
        }
    }
    timeChange() {
        this.saveOvertime();
    }
    isReadOnly() {
        return false;
    }
};
OvertimerDetailModalPage.ctorParameters = () => [
    { type: _ionic_angular__WEBPACK_IMPORTED_MODULE_8__["ModalController"] },
    { type: _services_auth_service__WEBPACK_IMPORTED_MODULE_7__["AuthService"] },
    { type: _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_6__["TasksServiceService"] },
    { type: _angular_platform_browser__WEBPACK_IMPORTED_MODULE_5__["DomSanitizer"] },
    { type: _services_overtime_service__WEBPACK_IMPORTED_MODULE_4__["OvertimeService"] }
];
OvertimerDetailModalPage.propDecorators = {
    historyComp: [{ type: _angular_core__WEBPACK_IMPORTED_MODULE_9__["ViewChild"], args: [_component_task_history_task_history_component__WEBPACK_IMPORTED_MODULE_3__["HistoryComponent"], { static: false },] }]
};
OvertimerDetailModalPage = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_9__["Component"])({
        selector: 'app-overtimer-detail-modal',
        template: _raw_loader_overtimer_detail_modal_page_html__WEBPACK_IMPORTED_MODULE_1__["default"],
        styles: [_overtimer_detail_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__["default"]]
    })
], OvertimerDetailModalPage);



/***/ }),

/***/ "wQvX":
/*!**********************************************************************************************************************!*\
  !*** ./node_modules/raw-loader/dist/cjs.js!./src/app/modals/overtimer-detail-modal/overtimer-detail-modal.page.html ***!
  \**********************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("<ion-header>\n  <ion-toolbar  *ngIf=\"overtimes.currentOvertime\" \n  color=\"light\"\n  >\n    <ion-buttons slot=\"start\">\n      <ion-back-button></ion-back-button>     \n      <ion-menu-button></ion-menu-button>\n\n    </ion-buttons>\n    <ion-title >Overtime</ion-title>   \n    <ion-buttons slot=\"end\">\n    <ion-button (click)=\"closeModal()\" >{{'COMMON.close' | translate}}</ion-button>\n  </ion-buttons>\n  </ion-toolbar>\n</ion-header>\n<ion-content *ngIf=\"overtimes.currentOvertime\">\n  \n<ion-item color=\"light\">\n  <ion-avatar slot=\"start\">\n    <img [src]=\"auth.avatarAdress(auth.getOperatorNameById(overtimes.currentOvertime.WorkerId))\">\n  </ion-avatar>\n <ion-label>{{ auth.getOperatorNameById(overtimes.currentOvertime.WorkerId) }}</ion-label>\n</ion-item>\n  <ion-item [color]=\"auth.getDictionaryColorById(overtimes.currentOvertime.State)\" >\n    <ion-icon name=\"pulse\" slot=\"start\" ></ion-icon>\n    <ion-label >{{'TASK.state' | translate }}</ion-label>\n    <ion-select  interface=\"popover\" placeholder=\"{{'TASK.state' | translate }}\" [(ngModel)]=\"overtimes.currentOvertime.State\" (ionChange)=\"changeState()\"   >\n      <ion-select-option *ngFor=\"let state of auth.overtimes_states\" [value] =\"state.Id\"  >{{state.Value}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n  <ion-item color=\"light\" >\n    <ion-icon name=\"stopwatch\" slot=\"start\" color=\"primary\" ></ion-icon>        \n    <ion-input type=\"number\"  [(ngModel)] = \"overtimes.currentOvertime.Time\" debounce=\"700\"  (ionChange)=\"timeChange()\" ></ion-input>            \n    <ion-chip [color]=\"overtimes.currentOvertime.Time>0 ? 'danger':'success'\"  *ngIf = \"overtimes.currentOvertime.Time!=0\">\n      <ion-icon name=\"stopwatch\"></ion-icon>\n      <ion-label>{{auth.timeSpendFormat(overtimes.currentOvertime.Time)}}</ion-label>\n    </ion-chip>   \n  </ion-item>\n  <ion-item>\n    <ion-avatar slot=\"start\">\n      <img [src]=\"auth.avatarAdress(auth.getOperatorNameById(overtimes.currentOvertime.VendorId))\">\n    </ion-avatar>\n  \n    <ion-label>{{'COMMON.operator' | translate}}</ion-label>\n    <ion-select  interface=\"popover\" placeholder=\"{{'COMMON.selectOperator' | translate}}\" [(ngModel)]=\"overtimes.currentOvertime.VendorId\"  \n    (ionChange)=\"changeVendor()\"  [disabled]=\"isReadOnly()\">\n      <ion-select-option *ngFor=\"let user of auth.operators\" [value] =\"user.Id\">{{user.Name}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n<ion-item>\n  <ion-label position=\"stacked\">\n    {{'COMMON.comment' | translate}} \n  </ion-label>\n  <ion-textarea  [(ngModel)]=\"overtimes.currentOvertime.Description\"  rows=\"3\"  debounce=\"700\" ></ion-textarea>\n</ion-item>\n<app-history [relObject]=\"overtimes.currentOvertime\" relObjectType=\"1001\" [disabled]=\"isReadOnly() || !this.overtimes.currentOvertime.Id\"  >\n</app-history>\n</ion-content>\n");

/***/ })

}]);
//# sourceMappingURL=default~modals-overtime-modal-overtime-modal-module~pages-activities-activities-module-es2015.js.map