(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["default~modals-workday-modal-workday-modal-module~pages-work-schedule-work-schedule-module"],{

/***/ "3plf":
/*!**********************************************!*\
  !*** ./src/app/services/overtime.service.ts ***!
  \**********************************************/
/*! exports provided: OvertimeService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OvertimeService", function() { return OvertimeService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _auth_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./auth.service */ "lGQG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var _angular_common_http__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @angular/common/http */ "tk/3");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! rxjs/operators */ "kU1M");






let OvertimeService = class OvertimeService {
    constructor(authService, http) {
        this.authService = authService;
        this.http = http;
        this.base_path = authService.serverAdress + '/overtimes';
        this.workerId = 0;
        this.state = 0;
        this.datefrom = new Date();
        this.dateto = new Date();
    }
    // Handle API errors
    handleError(error) {
        if (error.error instanceof ErrorEvent) {
            // A client-side or network error occurred. Handle it accordingly.
            console.error('An error occurred:', error.error.message);
        }
        else {
            // The backend returned an unsuccessful response code.
            // The response body may contain clues as to what went wrong,
            console.log(`Backend returned code ${error.status}, ` +
                `body was: ${error.error}`);
            console.log(JSON.stringify(error.error));
        }
        // return an observable with a user-facing error message
        return Object(rxjs__WEBPACK_IMPORTED_MODULE_4__["throwError"])('Something bad happened; please try again later.');
    }
    ;
    // Create a new item
    createItem(item) {
        return this.http
            .post(this.base_path, JSON.stringify(item), this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Get single student data by ID
    getItem(id) {
        return this.http
            .get(this.base_path + '/' + id, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Update item by id
    updateItem(id, item) {
        return this.http
            .put(this.base_path + '/' + id, JSON.stringify(item), this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Delete item by id
    deleteItem(id) {
        return this.http
            .delete(this.base_path + '/' + id, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // dodatkowe
    getOvertimeWorker() {
        return this.http
            .get(this.base_path + '/worker/' + this.workerId + '?state='
            + this.state + '&listtype=' + this.listtype + '&from=' + this.datefrom + '&to=' + this.dateto, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    getOvertimeWorkDay(workday) {
        return this.http
            .get(this.base_path + '/workday/' + workday, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    getOvertimeWorkerTotal() {
        return this.http
            .get(this.base_path + '/total/' + this.workerId, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
};
OvertimeService.ctorParameters = () => [
    { type: _auth_service__WEBPACK_IMPORTED_MODULE_1__["AuthService"] },
    { type: _angular_common_http__WEBPACK_IMPORTED_MODULE_3__["HttpClient"] }
];
OvertimeService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_2__["Injectable"])({
        providedIn: 'root'
    })
], OvertimeService);



/***/ }),

/***/ "N9MV":
/*!************************************************************!*\
  !*** ./src/app/modals/workday-modal/workday-modal.page.ts ***!
  \************************************************************/
/*! exports provided: WorkdayModalPage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WorkdayModalPage", function() { return WorkdayModalPage; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _raw_loader_workday_modal_page_html__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! raw-loader!./workday-modal.page.html */ "gIZS");
/* harmony import */ var _workday_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./workday-modal.page.scss */ "mvKd");
/* harmony import */ var _overtimer_detail_modal_overtimer_detail_modal_page__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./../overtimer-detail-modal/overtimer-detail-modal.page */ "umoA");
/* harmony import */ var _services_overtime_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../services/overtime.service */ "3plf");
/* harmony import */ var _angular_platform_browser__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @angular/platform-browser */ "jhN1");
/* harmony import */ var _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./../../services/tasks-service.service */ "TPCf");
/* harmony import */ var _services_auth_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./../../services/auth.service */ "lGQG");
/* harmony import */ var _services_work_day_service__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./../../services/work-day.service */ "djQ4");
/* harmony import */ var _ionic_angular__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @ionic/angular */ "TEn/");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var src_app_models_overtime__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! src/app/models/overtime */ "tGen");












let WorkdayModalPage = class WorkdayModalPage {
    constructor(modalController, workdays, authService, taskService, domSanitizer, overtimesService) {
        this.modalController = modalController;
        this.workdays = workdays;
        this.authService = authService;
        this.taskService = taskService;
        this.domSanitizer = domSanitizer;
        this.overtimesService = overtimesService;
    }
    ngOnInit() {
        this.getOvertimes();
        this.hours = [];
        for (let ii = 0; ii < 48; ii++) {
            this.hours.push(this.taskService.hoursMinutesIntToString(ii));
        }
    }
    ionViewWillEnter() {
        this.setting = true;
        this.timeForm = this.taskService
            .hoursMinutesIntToString(this.taskService.hoursMinutesTimeSpendToIdx(this.workdays.currentDay.WorkFrom));
        this.workTime = this.taskService
            .hoursMinutesIntToString(this.taskService.hoursMinutesTimeSpendToIdx(this.workdays.currentDay.TimeNorm));
        this.timeTo = this.taskService
            .hoursMinutesIntToString(this.taskService.hoursMinutesTimeSpendToIdx(this.workdays.currentDay.TimeNorm + this.workdays.currentDay.WorkFrom));
        this.setting = false;
    }
    saveDay() {
        if (this.workdays.currentDay.Id) {
            this.workdays.updateItem(this.workdays.currentDay.Id, this.workdays.currentDay).
                subscribe(res => {
            });
        }
        else {
            this.workdays.createItem(this.workdays.currentDay).
                subscribe(res => {
            });
        }
    }
    closeModal() {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            // zapis...
            /*
            if ( this.workdays.currentDay.Id){
              this.workdays.updateItem(this.workdays.currentDay.Id,this.workdays.currentDay).
              subscribe(res =>
                {
                 this.modalController.dismiss();
              });
            }
            else{
              this.workdays.createItem (this.workdays.currentDay).
              subscribe(res =>
                {
                 this.modalController.dismiss();
              });
            }
            */
            this.saveDay();
            yield this.modalController.dismiss();
        });
    }
    changeDayType() {
        console.log('changeDayType');
        if (this.authService.getDictionaryByNumberValue(this.workdays.currentDay.DayType, this.authService.day_types).Active) {
            this.workdays.currentDay.Active = 1;
        }
        else {
            this.workdays.currentDay.Active = 0;
        }
        // this.saveDay();
    }
    getOvertimes() {
        if (this.workdays.currentDay.Id) {
            this.overtimesService.getOvertimeWorkDay(this.workdays.currentDay.Id).subscribe(res => {
                this.overtimes = res;
            });
        }
    }
    deleteOvertime(ot) {
        this.overtimesService.deleteItem(ot.Id).subscribe(r => {
            this.getOvertimes();
        });
    }
    openOvertime(overtime) {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            this.overtimesService.currentOvertime = overtime;
            const otmodal = yield this.modalController.create({
                component: _overtimer_detail_modal_overtimer_detail_modal_page__WEBPACK_IMPORTED_MODULE_3__["OvertimerDetailModalPage"]
            });
            otmodal.onWillDismiss().then(dataReturned => {
                //   this.selectedOperator(dataReturned.data);
                this.overtimesService.currentOvertime = undefined;
                this.getOvertimes();
            });
            return yield otmodal.present();
        });
    }
    addOvertime() {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            this.overtimesService.currentOvertime =
                new src_app_models_overtime__WEBPACK_IMPORTED_MODULE_11__["Overtime"](this.workdays.currentDay.WorkerId, this.authService.getOperatorById(this.workdays.currentDay.WorkerId).SuperiorId, this.authService.overtimes_states[0].Id, this.workdays.currentDay.Date, this.workdays.currentDay.Id, this.workdays.currentDay.Day, 0, this.authService.operator.Id, '');
            const otmodal = yield this.modalController.create({
                component: _overtimer_detail_modal_overtimer_detail_modal_page__WEBPACK_IMPORTED_MODULE_3__["OvertimerDetailModalPage"]
            });
            otmodal.onWillDismiss().then(dataReturned => {
                //   this.selectedOperator(dataReturned.data);
                this.overtimesService.currentOvertime = undefined;
                this.getOvertimes();
            });
            return yield otmodal.present();
        });
    }
    changeTimeFrom() {
        // ustawiam wartość czasu od 
        let newVal = this.taskService.hoursMinutesToTimeSpend(this.taskService.hoursMinutesToInt(this.timeForm));
        console.log('changeTimeFrom');
        if (newVal !== this.workdays.currentDay.WorkFrom) {
            this.workdays.currentDay.WorkFrom = newVal;
            // poprawiam czas do zakładając niezmienność normy
            this.timeTo = this.taskService
                .hoursMinutesIntToString(this.taskService.hoursMinutesTimeSpendToIdx(this.workdays.currentDay.TimeNorm + this.workdays.currentDay.WorkFrom));
            //this.saveDay();
        }
    }
    changeWorkTime() {
        console.log('changeWorkTime');
        let newVal = this.taskService.hoursMinutesToTimeSpend(this.taskService.hoursMinutesToInt(this.workTime));
        if (newVal !== this.workdays.currentDay.TimeNorm) {
            this.workdays.currentDay.TimeNorm = newVal;
            // poprawiam czas do zakładając niezmienność normy
            this.timeTo = this.taskService
                .hoursMinutesIntToString(this.taskService.hoursMinutesTimeSpendToIdx(this.workdays.currentDay.TimeNorm + this.workdays.currentDay.WorkFrom));
            //this.saveDay();
        }
    }
    changeTimeTo() {
        let newVal = this.taskService.hoursMinutesToTimeSpend(this.taskService.hoursMinutesToInt(this.timeTo)) -
            this.workdays.currentDay.WorkFrom;
        if (this.workdays.currentDay.TimeNorm !== newVal) {
            console.log('changeTimeTo');
            this.workdays.currentDay.TimeNorm = newVal;
            // poprawiam wyświetlanie
            this.workTime = this.taskService
                .hoursMinutesIntToString(this.taskService.hoursMinutesTimeSpendToIdx(this.workdays.currentDay.TimeNorm));
            //this.saveDay();
        }
    }
};
WorkdayModalPage.ctorParameters = () => [
    { type: _ionic_angular__WEBPACK_IMPORTED_MODULE_9__["ModalController"] },
    { type: _services_work_day_service__WEBPACK_IMPORTED_MODULE_8__["WorkDayService"] },
    { type: _services_auth_service__WEBPACK_IMPORTED_MODULE_7__["AuthService"] },
    { type: _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_6__["TasksServiceService"] },
    { type: _angular_platform_browser__WEBPACK_IMPORTED_MODULE_5__["DomSanitizer"] },
    { type: _services_overtime_service__WEBPACK_IMPORTED_MODULE_4__["OvertimeService"] }
];
WorkdayModalPage = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_10__["Component"])({
        selector: 'app-workday-modal',
        template: _raw_loader_workday_modal_page_html__WEBPACK_IMPORTED_MODULE_1__["default"],
        styles: [_workday_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__["default"]]
    })
], WorkdayModalPage);



/***/ }),

/***/ "gIZS":
/*!****************************************************************************************************!*\
  !*** ./node_modules/raw-loader/dist/cjs.js!./src/app/modals/workday-modal/workday-modal.page.html ***!
  \****************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("<ion-header>\n  <ion-toolbar  *ngIf=\"workdays.currentDay\" \n  color=\"light\"\n  >\n    <ion-buttons slot=\"start\">\n      <ion-back-button></ion-back-button>     \n      <ion-menu-button></ion-menu-button>\n\n    </ion-buttons>\n    <ion-title [color]=\"workdays.getWorkDayForeColor(workdays.currentDay)\">{{authService.formatDate(workdays.currentDay.Date,true)}}</ion-title>   \n    <ion-buttons slot=\"end\">\n    <ion-button (click)=\"closeModal()\" >{{'COMMON.close' | translate}}</ion-button>\n  </ion-buttons>\n  </ion-toolbar>\n</ion-header>\n<ion-content *ngIf=\"workdays.currentDay\">\n  \n<ion-item color=\"light\">\n  <ion-avatar slot=\"start\">\n    <img [src]=\"authService.avatarAdress(authService.getOperatorNameById(workdays.currentDay.WorkerId))\">\n  </ion-avatar>\n <ion-label>{{ authService.getOperatorNameById(workdays.currentDay.WorkerId) }}</ion-label>\n</ion-item>\n  <ion-item  [color]=\"workdays.getWorkDayBackgroudColor(workdays.currentDay)\">\n    <ion-icon name=\"today\" slot=\"start\" [color]=\"workdays.getWorkDayForeColor(workdays.currentDay)\"></ion-icon>\n    <ion-label [color]=\"workdays.getWorkDayForeColor(workdays.currentDay)\">{{'HR.daytype' | translate }}</ion-label>\n    <ion-select  interface=\"popover\" placeholder=\"{{'HR.daytype' | translate }}\" [(ngModel)]=\"workdays.currentDay.DayType\" (ionChange)=\"changeDayType()\"   >\n      <ion-select-option *ngFor=\"let state of authService.day_types\" [value] =\"state.NumberValue\"  >{{state.Value}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n \n  <div *ngIf=\"workdays.currentDay.Active===1\">\n  <ion-item color=\"light\">\n    <ion-icon name=\"time\" slot=\"start\"></ion-icon>\n    <ion-label>Od</ion-label>      \n    <ion-select  interface=\"popover\" placeholder=\"czas od\" [(ngModel)]=\"timeForm\"  (ionChange)=\"changeTimeFrom()\"  >\n      <ion-select-option *ngFor=\"let ddd of hours\" [value] =\"ddd\">{{ddd}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n  <ion-item color=\"light\">\n    <ion-icon name=\"time-outline\" slot=\"start\"></ion-icon>\n    <ion-label> Do</ion-label>\n    <ion-select  interface=\"popover\" placeholder=\"czas od\" [(ngModel)]=\"timeTo\"  (ionChange)=\"changeTimeTo()\"  >\n      <ion-select-option *ngFor=\"let ddd of hours\" [value] =\"ddd\">{{ddd}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n  <ion-item color=\"light\">\n    <ion-icon name=\"stopwatch\" slot=\"start\"></ion-icon>\n    <ion-label>czas pracy</ion-label>      \n    <ion-select  interface=\"popover\" placeholder=\"czas od\" [(ngModel)]=\"workTime\"  (ionChange)=\"changeWorkTime()\"  >\n      <ion-select-option *ngFor=\"let ddd of hours\" [value] =\"ddd\">{{ddd}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n</div>\n<ion-item>\n  <ion-label position=\"stacked\">\n    {{'COMMON.comment' | translate}} \n  </ion-label>\n  <ion-textarea   [(ngModel)]=\"workdays.currentDay.Comment\"  rows=\"3\"  debounce=\"700\" ></ion-textarea>\n</ion-item>\n<ion-item-divider>\n  <ion-icon slot=\"start\" name=\"build\" ></ion-icon>\n  <ion-label>\n   Nadgodziny\n  </ion-label>  \n  <ion-button slot=\"end\" color=\"positive\"  (click)=\"addOvertime()\">\n    <ion-icon slot=\"icon-only\" name=\"add-circle\"></ion-icon>\n  </ion-button>\n</ion-item-divider>\n\n<ion-item *ngFor=\"let overtime of overtimes\">\n  <ion-avatar slot=\"start\">\n    <img [src]=\"authService.avatarAdress(authService.getOperatorNameById(overtime.WorkerId))\">\n  </ion-avatar>\n  <ion-label>\n  <h2>\n    {{authService.formatDate(overtime.Date)}}\n  </h2>\n  <p>{{overtime.Description}}      \n  </p>\n  <p>\n    <ion-chip outline  size=\"small\">    \n      <ion-avatar>\n        <img [src]=\"authService.avatarAdress(authService.getOperatorNameById(overtime.VendorId))\">\n      </ion-avatar>        \n      <ion-label>{{authService.getOperatorNameById(overtime.VendorId)}}</ion-label>            \n    </ion-chip>\n    <ion-chip outline  size=\"small\" color=\"success\" [color]=\"authService.getDictionaryColorById(overtime.State)\" >    \n      <ion-icon name=\"pulse\"  size=\"small\"></ion-icon>\n      <ion-label>\n        {{authService.getDictionaryValueById(overtime.State)}}\n      </ion-label>     \n    </ion-chip>     \n  </p>\n</ion-label>\n<ion-badge  [color]=\"overtime.Time>0 ? 'danger':'success'\" >\n  {{overtime.Time>0? '+':'-'}}\n  {{authService.timeSpendFormat( overtime.Time)}}\n</ion-badge>\n<ion-buttons slot=\"end\">\n  <ion-button (click)=\"deleteOvertime(overtime)\">\n    <ion-icon name=\"trash\" slot=\"icon-only\" color=\"danger\"></ion-icon>\n  </ion-button>\n  <ion-button (click)=\"openOvertime(overtime)\" color=\"success\">\n    <ion-icon name=\"open\" slot=\"icon-only\" color=\"danger\"></ion-icon>\n  </ion-button>\n</ion-buttons>\n</ion-item>\n</ion-content>\n");

/***/ }),

/***/ "mvKd":
/*!**************************************************************!*\
  !*** ./src/app/modals/workday-modal/workday-modal.page.scss ***!
  \**************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("\n/*# sourceMappingURL=data:application/json;base64,eyJ2ZXJzaW9uIjozLCJzb3VyY2VzIjpbXSwibmFtZXMiOltdLCJtYXBwaW5ncyI6IiIsImZpbGUiOiJzcmMvYXBwL21vZGFscy93b3JrZGF5LW1vZGFsL3dvcmtkYXktbW9kYWwucGFnZS5zY3NzIn0= */");

/***/ }),

/***/ "sW06":
/*!********************************************************************************!*\
  !*** ./src/app/modals/overtimer-detail-modal/overtimer-detail-modal.page.scss ***!
  \********************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("\n/*# sourceMappingURL=data:application/json;base64,eyJ2ZXJzaW9uIjozLCJzb3VyY2VzIjpbXSwibmFtZXMiOltdLCJtYXBwaW5ncyI6IiIsImZpbGUiOiJzcmMvYXBwL21vZGFscy9vdmVydGltZXItZGV0YWlsLW1vZGFsL292ZXJ0aW1lci1kZXRhaWwtbW9kYWwucGFnZS5zY3NzIn0= */");

/***/ }),

/***/ "tGen":
/*!************************************!*\
  !*** ./src/app/models/overtime.ts ***!
  \************************************/
/*! exports provided: Overtime */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Overtime", function() { return Overtime; });
class Overtime {
    constructor(worker, superiorId, stateId, date, dayId, day, time, vendor, comment) {
        this.WorkerId = worker;
        this.Date = date;
        this.Time = time;
        this.DayId = dayId;
        this.Day = day;
        this.RequesterId = vendor;
        this.VendorId = superiorId;
        this.State = stateId;
        this.Description = comment;
        this.TS = new Date();
        this.CreateTS = new Date();
        this.Active = 1;
    }
}


/***/ }),

/***/ "umoA":
/*!******************************************************************************!*\
  !*** ./src/app/modals/overtimer-detail-modal/overtimer-detail-modal.page.ts ***!
  \******************************************************************************/
/*! exports provided: OvertimerDetailModalPage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "OvertimerDetailModalPage", function() { return OvertimerDetailModalPage; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _raw_loader_overtimer_detail_modal_page_html__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! raw-loader!./overtimer-detail-modal.page.html */ "wQvX");
/* harmony import */ var _overtimer_detail_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./overtimer-detail-modal.page.scss */ "sW06");
/* harmony import */ var _component_task_history_task_history_component__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./../../component/task-history/task-history.component */ "bTDo");
/* harmony import */ var _services_overtime_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../services/overtime.service */ "3plf");
/* harmony import */ var _angular_platform_browser__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @angular/platform-browser */ "jhN1");
/* harmony import */ var _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./../../services/tasks-service.service */ "TPCf");
/* harmony import */ var _services_auth_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./../../services/auth.service */ "lGQG");
/* harmony import */ var _ionic_angular__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ionic/angular */ "TEn/");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @angular/core */ "fXoL");










let OvertimerDetailModalPage = class OvertimerDetailModalPage {
    constructor(modalController, auth, taskService, domSanitizer, overtimes) {
        this.modalController = modalController;
        this.auth = auth;
        this.taskService = taskService;
        this.domSanitizer = domSanitizer;
        this.overtimes = overtimes;
    }
    ngOnInit() {
    }
    closeModal() {
        return Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"])(this, void 0, void 0, function* () {
            // zapis...
            yield this.modalController.dismiss();
            /*
            if ( this.workdays.currentDay.Id){
              this.workdays.updateItem(this.workdays.currentDay.Id,this.workdays.currentDay).
              subscribe(res =>
                {
                 this.modalController.dismiss();
              });
            }
            else{
              this.workdays.createItem (this.workdays.currentDay).
              subscribe(res =>
                {
                 this.modalController.dismiss();
              });
            }
            */
            // await this.modalController.dismiss();
        });
    }
    changeState() {
        let textInfo = this.auth.getDictionaryValueById(this.overtimes.currentOvertime.State);
        /*
         if ( this.oldTask!== undefined){
           textInfo = this.auth.getDictionaryValueById(this.oldTask.StateId) +'->' + textInfo;
         }
         */
        this.historyComp.addToHisory(105, this.overtimes.currentOvertime.State, textInfo, 0, 0, 0, 0);
        this.saveOvertime();
    }
    changeVendor() {
        this.saveOvertime();
    }
    saveOvertime() {
        console.log('saveOvertime');
        if (!this.overtimes.currentOvertime.Id) {
            this.overtimes.createItem(this.overtimes.currentOvertime).subscribe(res => {
                this.overtimes.currentOvertime = res;
                console.log('overtime added Updated');
            });
        }
        else {
            this.overtimes.updateItem(this.overtimes.currentOvertime.Id, this.overtimes.currentOvertime)
                .subscribe(res => {
                console.log('overtimeUpdated');
            });
        }
    }
    timeChange() {
        this.saveOvertime();
    }
    isReadOnly() {
        return false;
    }
};
OvertimerDetailModalPage.ctorParameters = () => [
    { type: _ionic_angular__WEBPACK_IMPORTED_MODULE_8__["ModalController"] },
    { type: _services_auth_service__WEBPACK_IMPORTED_MODULE_7__["AuthService"] },
    { type: _services_tasks_service_service__WEBPACK_IMPORTED_MODULE_6__["TasksServiceService"] },
    { type: _angular_platform_browser__WEBPACK_IMPORTED_MODULE_5__["DomSanitizer"] },
    { type: _services_overtime_service__WEBPACK_IMPORTED_MODULE_4__["OvertimeService"] }
];
OvertimerDetailModalPage.propDecorators = {
    historyComp: [{ type: _angular_core__WEBPACK_IMPORTED_MODULE_9__["ViewChild"], args: [_component_task_history_task_history_component__WEBPACK_IMPORTED_MODULE_3__["HistoryComponent"], { static: false },] }]
};
OvertimerDetailModalPage = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_9__["Component"])({
        selector: 'app-overtimer-detail-modal',
        template: _raw_loader_overtimer_detail_modal_page_html__WEBPACK_IMPORTED_MODULE_1__["default"],
        styles: [_overtimer_detail_modal_page_scss__WEBPACK_IMPORTED_MODULE_2__["default"]]
    })
], OvertimerDetailModalPage);



/***/ }),

/***/ "wQvX":
/*!**********************************************************************************************************************!*\
  !*** ./node_modules/raw-loader/dist/cjs.js!./src/app/modals/overtimer-detail-modal/overtimer-detail-modal.page.html ***!
  \**********************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("<ion-header>\n  <ion-toolbar  *ngIf=\"overtimes.currentOvertime\" \n  color=\"light\"\n  >\n    <ion-buttons slot=\"start\">\n      <ion-back-button></ion-back-button>     \n      <ion-menu-button></ion-menu-button>\n\n    </ion-buttons>\n    <ion-title >Overtime</ion-title>   \n    <ion-buttons slot=\"end\">\n    <ion-button (click)=\"closeModal()\" >{{'COMMON.close' | translate}}</ion-button>\n  </ion-buttons>\n  </ion-toolbar>\n</ion-header>\n<ion-content *ngIf=\"overtimes.currentOvertime\">\n  \n<ion-item color=\"light\">\n  <ion-avatar slot=\"start\">\n    <img [src]=\"auth.avatarAdress(auth.getOperatorNameById(overtimes.currentOvertime.WorkerId))\">\n  </ion-avatar>\n <ion-label>{{ auth.getOperatorNameById(overtimes.currentOvertime.WorkerId) }}</ion-label>\n</ion-item>\n  <ion-item [color]=\"auth.getDictionaryColorById(overtimes.currentOvertime.State)\" >\n    <ion-icon name=\"pulse\" slot=\"start\" ></ion-icon>\n    <ion-label >{{'TASK.state' | translate }}</ion-label>\n    <ion-select  interface=\"popover\" placeholder=\"{{'TASK.state' | translate }}\" [(ngModel)]=\"overtimes.currentOvertime.State\" (ionChange)=\"changeState()\"   >\n      <ion-select-option *ngFor=\"let state of auth.overtimes_states\" [value] =\"state.Id\"  >{{state.Value}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n  <ion-item color=\"light\" >\n    <ion-icon name=\"stopwatch\" slot=\"start\" color=\"primary\" ></ion-icon>        \n    <ion-input type=\"number\"  [(ngModel)] = \"overtimes.currentOvertime.Time\" debounce=\"700\"  (ionChange)=\"timeChange()\" ></ion-input>            \n    <ion-chip [color]=\"overtimes.currentOvertime.Time>0 ? 'danger':'success'\"  *ngIf = \"overtimes.currentOvertime.Time!=0\">\n      <ion-icon name=\"stopwatch\"></ion-icon>\n      <ion-label>{{auth.timeSpendFormat(overtimes.currentOvertime.Time)}}</ion-label>\n    </ion-chip>   \n  </ion-item>\n  <ion-item>\n    <ion-avatar slot=\"start\">\n      <img [src]=\"auth.avatarAdress(auth.getOperatorNameById(overtimes.currentOvertime.VendorId))\">\n    </ion-avatar>\n  \n    <ion-label>{{'COMMON.operator' | translate}}</ion-label>\n    <ion-select  interface=\"popover\" placeholder=\"{{'COMMON.selectOperator' | translate}}\" [(ngModel)]=\"overtimes.currentOvertime.VendorId\"  \n    (ionChange)=\"changeVendor()\"  [disabled]=\"isReadOnly()\">\n      <ion-select-option *ngFor=\"let user of auth.operators\" [value] =\"user.Id\">{{user.Name}}</ion-select-option>    \n    </ion-select>  \n  </ion-item>\n<ion-item>\n  <ion-label position=\"stacked\">\n    {{'COMMON.comment' | translate}} \n  </ion-label>\n  <ion-textarea  [(ngModel)]=\"overtimes.currentOvertime.Description\"  rows=\"3\"  debounce=\"700\" ></ion-textarea>\n</ion-item>\n<app-history [relObject]=\"overtimes.currentOvertime\" relObjectType=\"1001\" [disabled]=\"isReadOnly() || !this.overtimes.currentOvertime.Id\"  >\n</app-history>\n</ion-content>\n");

/***/ })

}]);
//# sourceMappingURL=default~modals-workday-modal-workday-modal-module~pages-work-schedule-work-schedule-module-es2015.js.map