(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["pages-mappings-mappings-module"],{

/***/ "6Yp4":
/*!*****************************************************!*\
  !*** ./src/app/services/mapping-service.service.ts ***!
  \*****************************************************/
/*! exports provided: MappingServiceService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MappingServiceService", function() { return MappingServiceService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _auth_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./auth.service */ "lGQG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var _angular_common_http__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @angular/common/http */ "tk/3");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! rxjs/operators */ "kU1M");






let MappingServiceService = class MappingServiceService {
    constructor(authService, http) {
        this.authService = authService;
        this.http = http;
        this.base_path = authService.serverAdress + '/Mappings';
    }
    // Handle API errors
    handleError(error) {
        if (error.error instanceof ErrorEvent) {
            // A client-side or network error occurred. Handle it accordingly.
            console.error('An error occurred:', error.error.message);
        }
        else {
            // The backend returned an unsuccessful response code.
            // The response body may contain clues as to what went wrong,
            console.log(`Backend returned code ${error.status}, ` +
                `body was: ${error.error}`);
            console.log(JSON.stringify(error.error));
        }
        // return an observable with a user-facing error message
        return Object(rxjs__WEBPACK_IMPORTED_MODULE_4__["throwError"])('Something bad happened; please try again later.');
    }
    ;
    getMappingsList() {
        let address = this.base_path;
        return this.http
            .get(address, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    getMappingsSourceDict() {
        let address = this.base_path + '/SourceDictionary';
        return this.http
            .get(address, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    getMappingsDestinationDict() {
        let address = this.base_path + '/DestinationDictionary';
        return this.http
            .get(address, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Create a new item
    createItem(item) {
        return this.http
            .post(this.base_path, JSON.stringify(item, this.authService.replacer), this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Get single student data by ID
    getItem(id) {
        return this.http
            .get(this.base_path + '/' + id, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Update item by id
    updateItem(id, item) {
        return this.http
            .put(this.base_path + '/' + id, JSON.stringify(item, this.authService.replacer), this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
    // Delete item by id
    deleteItem(id) {
        return this.http
            .delete(this.base_path + '/' + id, this.authService.getHtttpOptions())
            .pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["retry"])(2), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_5__["catchError"])(this.handleError));
    }
};
MappingServiceService.ctorParameters = () => [
    { type: _auth_service__WEBPACK_IMPORTED_MODULE_1__["AuthService"] },
    { type: _angular_common_http__WEBPACK_IMPORTED_MODULE_3__["HttpClient"] }
];
MappingServiceService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_2__["Injectable"])({
        providedIn: 'root'
    })
], MappingServiceService);



/***/ }),

/***/ "8FHP":
/*!***********************************************************!*\
  !*** ./src/app/pages/mappings/mappings-routing.module.ts ***!
  \***********************************************************/
/*! exports provided: MappingsPageRoutingModule */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MappingsPageRoutingModule", function() { return MappingsPageRoutingModule; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var _angular_router__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @angular/router */ "tyNb");
/* harmony import */ var _mappings_page__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./mappings.page */ "gI0J");




const routes = [
    {
        path: '',
        component: _mappings_page__WEBPACK_IMPORTED_MODULE_3__["MappingsPage"]
    }
];
let MappingsPageRoutingModule = class MappingsPageRoutingModule {
};
MappingsPageRoutingModule = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_1__["NgModule"])({
        imports: [_angular_router__WEBPACK_IMPORTED_MODULE_2__["RouterModule"].forChild(routes)],
        exports: [_angular_router__WEBPACK_IMPORTED_MODULE_2__["RouterModule"]],
    })
], MappingsPageRoutingModule);



/***/ }),

/***/ "W9S3":
/*!***************************************************!*\
  !*** ./src/app/pages/mappings/mappings.page.scss ***!
  \***************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("\n/*# sourceMappingURL=data:application/json;base64,eyJ2ZXJzaW9uIjozLCJzb3VyY2VzIjpbXSwibmFtZXMiOltdLCJtYXBwaW5ncyI6IiIsImZpbGUiOiJzcmMvYXBwL3BhZ2VzL21hcHBpbmdzL21hcHBpbmdzLnBhZ2Uuc2NzcyJ9 */");

/***/ }),

/***/ "WDCk":
/*!*****************************************************************************************!*\
  !*** ./node_modules/raw-loader/dist/cjs.js!./src/app/pages/mappings/mappings.page.html ***!
  \*****************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("<ion-header>\r\n  <ion-toolbar>\r\n    <ion-title>Mapowania</ion-title>\r\n  </ion-toolbar>\r\n</ion-header>\r\n\r\n\r\n<ion-content>\r\n<ion-item-divider>Źródło</ion-item-divider>\r\n  <ion-item>\r\n    <ion-searchbar type=\"text\" [(ngModel)]=\"sourceFilter\"></ion-searchbar>\r\n</ion-item>\r\n<ion-item *ngIf=\"sourceDict && sourceFilter && filteredSourceDict(sourceDict, sourceFilter).length<35\" color=\"light\">\r\n  <ion-label class=\"ion-text-wrap\">\r\n    <p>\r\n    <ion-chip (click)=\"sourceValue=ddd.Name\" outlie size=\"small\" *ngFor=\"let ddd of filteredSourceDict(sourceDict, sourceFilter)\">{{ddd.Name}}</ion-chip>\r\n    </p>\r\n  </ion-label>\r\n</ion-item>\r\n<ion-item>\r\n  <ion-label>Wartość Źródłowa</ion-label>\r\n  <ion-input type=\"text\" [(ngModel)]=\"sourceValue\"></ion-input>\r\n</ion-item>\r\n\r\n\r\n<ion-item-divider color=\"warning\">Cel</ion-item-divider>\r\n  <ion-item>\r\n    <ion-searchbar type=\"text\" [(ngModel)]=\"destinationFilter\"></ion-searchbar>\r\n</ion-item>\r\n<ion-item color=\"light\" *ngIf=\"destDict && destinationFilter && filteredSourceDict(destDict, destinationFilter).length<35\">\r\n  <ion-label class=\"ion-text-wrap\">\r\n    <p>\r\n    <ion-chip (click)=\"destinationValue=ddd.Name\" outlie size=\"small\" \r\n    *ngFor=\"let ddd of filteredSourceDict(destDict, destinationFilter)\">{{ddd.Name}}</ion-chip>\r\n    </p>\r\n  </ion-label>\r\n</ion-item>\r\n<ion-item>\r\n  <ion-label>Wartość Docelowa</ion-label>\r\n  <ion-input type=\"text\" [(ngModel)]=\"destinationValue\"></ion-input>\r\n</ion-item>\r\n<ion-button (click)=\"addMapping()\"  [disabled]=\"!destinationValue || !sourceValue||  destinationValue==='' || sourceValue===''\">\r\n  Dodaj Mapowanie\r\n</ion-button>\r\n\r\n<ion-item-divider>Lista Mapowan</ion-item-divider>\r\n\r\n<ion-item *ngFor=\"let mapp of mappingsFilters()\">\r\n<ion-label>{{mapp.SourceValue}}</ion-label>\r\n<ion-badge>{{mapp.MapToValue}}</ion-badge>\r\n<ion-buttons slot=\"end\">\r\n  <ion-button (click)=\"removeMapping(mapp)\">\r\n    <ion-icon name=\"trash\" color=\"danger\"></ion-icon>\r\n  </ion-button>\r\n</ion-buttons>\r\n</ion-item>\r\n\r\n</ion-content>\r\n");

/***/ }),

/***/ "gI0J":
/*!*************************************************!*\
  !*** ./src/app/pages/mappings/mappings.page.ts ***!
  \*************************************************/
/*! exports provided: MappingsPage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MappingsPage", function() { return MappingsPage; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _raw_loader_mappings_page_html__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! raw-loader!./mappings.page.html */ "WDCk");
/* harmony import */ var _mappings_page_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./mappings.page.scss */ "W9S3");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var src_app_models_mapping__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! src/app/models/mapping */ "oB1a");
/* harmony import */ var src_app_services_mapping_service_service__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! src/app/services/mapping-service.service */ "6Yp4");






let MappingsPage = class MappingsPage {
    constructor(mappingServices) {
        this.mappingServices = mappingServices;
        this.mappingServices.getMappingsSourceDict().subscribe(res => {
            this.sourceDict = res;
        });
        this.mappingServices.getMappingsDestinationDict().subscribe(res => {
            this.destDict = res;
        });
        this.getMappings();
    }
    filteredSourceDict(list, filter) {
        if (filter && list) {
            return list.filter(t => (t.Symbol && t.Symbol.toLowerCase().indexOf(filter.toLowerCase()) > -1)
                || (t.Name && t.Name.toLowerCase().indexOf(filter.toLowerCase()) > -1));
        }
    }
    ngOnInit() {
        this.getMappings();
    }
    getMappings() {
        this.mappingServices.getMappingsList().subscribe(res => {
            this.mappings = res;
        });
    }
    addMapping() {
        let newMapping = new src_app_models_mapping__WEBPACK_IMPORTED_MODULE_4__["Mapping"]();
        newMapping.MappingId = 0;
        newMapping.SourceValue = this.sourceValue;
        newMapping.MapToValue = this.destinationValue;
        this.mappingServices.createItem(newMapping).subscribe(res => {
            this.getMappings();
        });
    }
    removeMapping(mapp) {
        this.mappingServices.deleteItem(mapp.Id).subscribe(res => {
            this.getMappings();
        });
    }
    mappingsFilters() {
        if (this.mappings) {
            return this.mappings.filter(t => (!this.sourceFilter || this.sourceFilter === '' ||
                (this.sourceFilter && this.sourceFilter !== '' && t.SourceValue.toLowerCase().indexOf(this.sourceFilter.toLowerCase()) > -1))
                && (!this.destinationFilter || this.destinationFilter === '' ||
                    (this.destinationFilter && this.destinationFilter !== ''
                        && t.MapToValue.toLowerCase().indexOf(this.destinationFilter.toLowerCase()) > -1)));
        }
    }
};
MappingsPage.ctorParameters = () => [
    { type: src_app_services_mapping_service_service__WEBPACK_IMPORTED_MODULE_5__["MappingServiceService"] }
];
MappingsPage = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_3__["Component"])({
        selector: 'app-mappings',
        template: _raw_loader_mappings_page_html__WEBPACK_IMPORTED_MODULE_1__["default"],
        styles: [_mappings_page_scss__WEBPACK_IMPORTED_MODULE_2__["default"]]
    })
], MappingsPage);



/***/ }),

/***/ "oB1a":
/*!***********************************!*\
  !*** ./src/app/models/mapping.ts ***!
  \***********************************/
/*! exports provided: Mapping */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Mapping", function() { return Mapping; });
class Mapping {
}


/***/ }),

/***/ "wJ6U":
/*!***************************************************!*\
  !*** ./src/app/pages/mappings/mappings.module.ts ***!
  \***************************************************/
/*! exports provided: MappingsPageModule */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MappingsPageModule", function() { return MappingsPageModule; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var _angular_common__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @angular/common */ "ofXK");
/* harmony import */ var _angular_forms__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @angular/forms */ "3Pt+");
/* harmony import */ var _ionic_angular__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ionic/angular */ "TEn/");
/* harmony import */ var _mappings_routing_module__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./mappings-routing.module */ "8FHP");
/* harmony import */ var _mappings_page__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./mappings.page */ "gI0J");







let MappingsPageModule = class MappingsPageModule {
};
MappingsPageModule = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_1__["NgModule"])({
        imports: [
            _angular_common__WEBPACK_IMPORTED_MODULE_2__["CommonModule"],
            _angular_forms__WEBPACK_IMPORTED_MODULE_3__["FormsModule"],
            _ionic_angular__WEBPACK_IMPORTED_MODULE_4__["IonicModule"],
            _mappings_routing_module__WEBPACK_IMPORTED_MODULE_5__["MappingsPageRoutingModule"]
        ],
        declarations: [_mappings_page__WEBPACK_IMPORTED_MODULE_6__["MappingsPage"]]
    })
], MappingsPageModule);



/***/ })

}]);
//# sourceMappingURL=pages-mappings-mappings-module-es2015.js.map